unit demoborder;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  ExtCtrls, StdCtrls;

type
  TfraDemoBorders = class(TFrame)
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    Button3: TButton;
    cbOpenAfterSave: TCheckBox;
    Panel3: TPanel;
    Label2: TLabel;
    Image1: TImage;
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}
uses XLSFile, XLSFormat, Main;

procedure TfraDemoBorders.Button3Click(Sender: TObject);
var
  xf: TXLSFile;
  I: Integer;
  P: TXLBorderStyle;
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  { Create TXLSFile object.
    After creation it contains one sheet }
  xf:= TXLSFile.Create;
  try
    with xf.Workbook.Sheets[0] do
      for P:=  Low(TXLBorderStyle) to High(TXLBorderStyle) do
      begin
        I:= ord(P);
        { Set cell value. Row and column indexes are 0-based }
        Cells[I*2, 2].Value:= 'Demo';
        { Set cell borders style and color }
        Cells[I*2, 2].BorderStyle[xlBorderAll]:= P;
        Cells[I*2, 2].BorderColorIndex[xlBorderAll]:= xlColorBlack;
      end;
    { Save workbook data to Excel file }
    xf.SaveAs(FileName);
  finally
    xf.Destroy;
  end;

  if cbOpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

end.
