unit demodbgrid;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Db, DBTables, XLSExportComp, Grids, DBGrids, StdCtrls, ExtCtrls, Dialogs;

type
  TfraDemoDBGrid = class(TFrame)
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Table1: TTable;
    XLSExportDBGrid1: TXLSExportDBGrid;
    ColorDialog1: TColorDialog;
    XLSExportFile1: TXLSExportFile;
    Panel2: TPanel;
    Label2: TLabel;
    Panel3: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    cb1OpenAfterSave: TCheckBox;
    Panel4: TPanel;
    Label1: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    p1Odd: TPanel;
    btn1Odd: TButton;
    btn1Even: TButton;
    p1Even: TPanel;
    Database1: TDatabase;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table1Addr1: TStringField;
    Table1Addr2: TStringField;
    Table1City: TStringField;
    Table1State: TStringField;
    Table1Zip: TStringField;
    Table1Country: TStringField;
    Table1Phone: TStringField;
    Table1FAX: TStringField;
    Table1TaxRate: TFloatField;
    Table1Contact: TStringField;
    Table1LastInvoiceDate: TDateTimeField;
    procedure Button1Click(Sender: TObject);
    procedure btn1OddClick(Sender: TObject);
    procedure btn1EvenClick(Sender: TObject);
    procedure XLSExportDBGrid1SaveColumn(Column: TColumn; XLSCell: TCell);
  private
    { Private declarations }
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.DFM}
uses XLSFormat, Main;

constructor TfraDemoDBGrid.Create(AOwner: TComponent);
begin
  inherited;
  Table1.Open;
end;

procedure TfraDemoDBGrid.Button1Click(Sender: TObject);
var
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  XLSExportFile1.Workbook.Clear;
  XLSExportFile1.Workbook.Sheets.Add('Sheet1');

  { Export DBGrid data to sheet 0 starting at row 0 column 0.
    All indexes are 0-based }
  XLSExportDBGrid1.ExportData(0, 0, 0);
  { Save workbook data to Excel file }
  XLSExportFile1.SaveToFile(FileName);

  if cb1OpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK)
end;

procedure TfraDemoDBGrid.btn1OddClick(Sender: TObject);
begin
  ColorDialog1.Color:= p1Odd.Color;
  if ColorDialog1.Execute then
    p1Odd.Color:= ColorDialog1.Color;
end;

procedure TfraDemoDBGrid.btn1EvenClick(Sender: TObject);
begin
  ColorDialog1.Color:= p1Even.Color;
  if ColorDialog1.Execute then
    p1Even.Color:= ColorDialog1.Color;
end;

procedure TfraDemoDBGrid.XLSExportDBGrid1SaveColumn(Column: TColumn;
  XLSCell: TCell);
begin
  { Cell export event:
    here you can override default exporting options.
    Column is DBGrid column, XLSCell is worksheet cell }

  { Set cell fill pattern and color }
  XLSCell.FillPattern:= xlPatternSolid;
  if (XLSCell.Row mod 2) = 0 then
    XLSCell.FillPatternBGColorIndex:=
      ColorToXLSColorIndex(p1Odd.Color)
  else
    XLSCell.FillPatternBGColorIndex:=
      ColorToXLSColorIndex(p1Even.Color);
end;

end.
