unit demomultds;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Db, DBTables, XLSExportComp;

type
  TfraDemoMultiDSOneSheet = class(TFrame)
    Panel1: TPanel;
    Label1: TLabel;
    Label9: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    Button3: TButton;
    cbOpenAfterSave: TCheckBox;
    ScrollBox1: TScrollBox;
    Label2: TLabel;
    Label3: TLabel;
    Image1: TImage;
    Memo2: TMemo;
    XLSExportFile1: TXLSExportFile;
    XLSExportDataSource1: TXLSExportDataSource;
    MyBase2: TDatabase;
    Ords: TTable;
    OrdsCustNo: TFloatField;
    OrdsOrderNo: TFloatField;
    OrdsSaleDate: TDateTimeField;
    OrdsItemsTotal: TCurrencyField;
    OrdsTaxRate: TFloatField;
    OrdsFreight: TCurrencyField;
    OrdsAmountPaid: TCurrencyField;
    Cust: TTable;
    CustCustNo: TFloatField;
    CustCompany: TStringField;
    dsCust: TDataSource;
    dsOrds: TDataSource;
    procedure Button3Click(Sender: TObject);
    procedure XLSExportDataSource1SaveField(Field: TField; XLSCell: TCell);
    procedure XLSExportDataSource1SaveFooter(FieldIndex: Integer;
      XLSCell: TCell; var TotalCalcType: TTotalCalcType;
      var TotalRange: String);
    procedure XLSExportDataSource1SaveTitle(FieldIndex: Integer;
      XLSCell: TCell);
  private
    { Private declarations }
  public
    { Public declarations }
     constructor Create(AOwner: TComponent); override;
  end;

implementation
{$R *.DFM}

uses XLSFile, XLSFormat, Main;

constructor TfraDemoMultiDSOneSheet.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  MyBase2.AliasName:= 'DBDEMOS';
end;

procedure TfraDemoMultiDSOneSheet.Button3Click(Sender: TObject);
var
  FileName: String;
  OldCursor: TCursor;
  Row: Integer;
begin
  FileName:= GetNextDemoFileName;
  OldCursor:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;

  Row:= 0;
  try
    XLSExportFile1.Workbook.Clear;
    XLSExportFile1.Workbook.Sheets.Add('Sheet1');

    Cust.Open;
    Ords.Open;
    while not Cust.Eof do
    begin
      if Ords.RecordCount > 0 then
      begin
        with XLSExportFile1.Workbook.Sheets[0] do
        begin
          { header }
          { Set cell value }
          Cells[Row, 0].Value:= 'Customer: (' +
            FormatFloat('0000',CustCustNo.Value) + ') ' +
            CustCompany.Value;
          { Set cell font color and style }
          Cells[Row, 0].FontBold:= True;
          Cells[Row, 0].FontColorIndex:= xlColorRed;

          Row:= Row + 1;

          { detail }
          { Export DataSource data to sheet 0 starting at row Row column 0.
            All indexes are 0-based }
          XLSExportDataSource1.ExportData(0, Row , 0);

          { detail recordcount + title row
            + footer row + 1 separator row}
          Row:= Row + 2 + Ords.RecordCount + 1;
        end;
      end;

      Cust.Next;
    end;

    { save workbook data to file }
    XLSExportFile1.SaveToFile(FileName);
  finally
    Ords.Close;
    Cust.Close;
    MyBase2.Connected:= False;
    Screen.Cursor:= OldCursor;
  end;

  if cbOpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

procedure TfraDemoMultiDSOneSheet.XLSExportDataSource1SaveField(
  Field: TField; XLSCell: TCell);
begin
  { Cell export event:
    here you can customise default exporting options.
    Field is DataSource field, XLSCell is worksheet cell }

  { Set blue font color for ItemTotals field }
  if Field.FieldName = 'ItemsTotal' then
  begin
    XLSCell.FontColorIndex:= xlColorBlue;
  end;
end;

procedure TfraDemoMultiDSOneSheet.XLSExportDataSource1SaveFooter(
  FieldIndex: Integer; XLSCell: TCell; var TotalCalcType: TTotalCalcType;
  var TotalRange: String);
begin
  { Footer row export event:
    here you can add totals after exporting DataSource fields }

  case FieldIndex of
    0: begin
         { Place 'Totals' string to the footer for field 0}
         TotalCalcType:= tcUserDef;
         XLSCell.Value:= 'Totals';
       end;
    2,
    5 : begin
         { Place sum total to the footer for fields 2, 5}
         TotalCalcType:= tcSum;
       end;
  end;
  { set bold style for all totals }
  XLSCell.FontBold:= True;
end;

procedure TfraDemoMultiDSOneSheet.XLSExportDataSource1SaveTitle(
  FieldIndex: Integer; XLSCell: TCell);
begin
  { Title row export event:
    here you can customise DataSource title export }

  { Set font color for title cells }
  XLSCell.FontColorIndex:= xlColorWhite;
  { Set fill pattern and color for title cells }  
  XLSCell.FillPatternBGColorIndex:= xlColorDarkBlue;
  XLSCell.FillPattern:= xlPatternSolid;
end;

end.
