unit demoread;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfraDemoRead = class(TFrame)
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    Label3: TLabel;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Button3: TButton;
    cbOpenAfterSave: TCheckBox;
    Panel3: TPanel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    lblSheets: TLabel;
    lblCells: TLabel;
    lblTime: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation            
{$R *.DFM}

uses XLSFile, XLSFormat, Main;

procedure TfraDemoRead.Button2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    Edit1.Text:= OpenDialog1.FileName;
end;

procedure TfraDemoRead.Button3Click(Sender: TObject);
var
  xf: TXLSFile;
  FileName: String;
  I, CellsCount: Integer;
  T: longword;
  D: TDateTime;
  OldCursor: TCursor;
begin
  FileName:= GetNextDemoFileName;

  {check filenames errors}
  if not FileExists(Edit1.Text) then
  begin
    Application.MessageBox('File does not exist !', PChar(Caption), MB_OK);
    Exit;
  end;

  OldCursor:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;
  D:= Now;

  { Create TXLSFile object.
  After creation it contains one sheet }
  xf:= TXLSFile.Create;
  try
    {read data}
    xf.OpenFile(Edit1.Text);

    lblSheets.Caption:= IntToStr(xf.Workbook.Sheets.Count);
    CellsCount:= 0;
    for I:= 0 to xf.Workbook.Sheets.Count - 1 do
      CellsCount:= CellsCount + xf.Workbook.Sheets[I].Cells.Count;
    lblCells.Caption:= IntToStr(CellsCount);

    {modify data - write demo label into each sheet}
    for I:= 0 to xf.Workbook.Sheets.Count - 1 do
      with xf.Workbook.Sheets[I] do
      begin
        Cells[0, 0].Value:= 'TXLSFile Demo';
        Cells[0, 0].HAlign:= xlHAlignLeft;
        Cells[0, 0].VAlign:= xlVAlignTop;
        Cells[0, 0].FontHeight:= 10;
        Cells[0, 0].FontColorIndex:= xlColorRed;
        Cells[0, 0].FontBold:= True;
      end;

    {write data}
    xf.SaveAs(FileName);
  finally
    xf.Destroy;
    Screen.Cursor:= OldCursor;
  end;

  T:= round((Now - D) * SecsPerDay);
  lblTime.Caption:= IntToStr(T) + ' seconds';

  if cbOpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

end.
